Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 9132)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 9133)
@@ -185,8 +185,9 @@
     <Compile Include="Regression\Nguyen\NguyenFunctionTwo.cs" />
     <Compile Include="Regression\Nguyen\NguyenInstanceProvider.cs" />
-    <Compile Include="Regression\RealWorld\IRealWorldRegressionDataDescriptor.cs" />
+    <Compile Include="Regression\RealWorld\ChemicalOne.cs" />
+    <Compile Include="Regression\RealWorld\Housing.cs" />
     <Compile Include="Regression\RealWorld\RealWorldRegressionInstanceProvider.cs" />
-    <Compile Include="Regression\RealWorld\RealWorldResourceRegressionDataDescriptor.cs" />
     <Compile Include="Regression\RealWorld\Tower.cs" />
+    <Compile Include="Regression\RegressionDataDescriptor.cs" />
     <Compile Include="Regression\RegressionImportType.cs" />
     <Compile Include="Regression\RegressionInstanceProvider.cs" />
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ArtificialRegressionDataDescriptor.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ArtificialRegressionDataDescriptor.cs	(revision 9132)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ArtificialRegressionDataDescriptor.cs	(revision 9133)
@@ -24,27 +24,8 @@
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public abstract class ArtificialRegressionDataDescriptor : IDataDescriptor {
-    public abstract string Name { get; }
-    public abstract string Description { get; }
-
-    protected abstract string TargetVariable { get; }
-    protected abstract string[] VariableNames { get; }
-    protected abstract string[] AllowedInputVariables { get; }
-    protected abstract int TrainingPartitionStart { get; }
-    protected abstract int TrainingPartitionEnd { get; }
-    protected abstract int TestPartitionStart { get; }
-    protected abstract int TestPartitionEnd { get; }
-
+  public abstract class ArtificialRegressionDataDescriptor : RegressionDataDescriptor {
     public IRegressionProblemData GenerateRegressionData() {
       Dataset dataset = new Dataset(VariableNames, this.GenerateValues());
-
-      RegressionProblemData regData = new RegressionProblemData(dataset, AllowedInputVariables, TargetVariable);
-      regData.Name = this.Name;
-      regData.Description = this.Description;
-      regData.TrainingPartition.Start = this.TrainingPartitionStart;
-      regData.TrainingPartition.End = this.TrainingPartitionEnd;
-      regData.TestPartition.Start = this.TestPartitionStart;
-      regData.TestPartition.End = this.TestPartitionEnd;
-      return regData;
+      return GenerateRegressionData(dataset);
     }
 
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/ChemicalOne.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/ChemicalOne.cs	(revision 9133)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/ChemicalOne.cs	(revision 9133)
@@ -0,0 +1,38 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class ChemicalOne : ResourceRegressionDataDescriptor {
+    public override string Name { get { return "Chemical-I"; } }
+    public override string Description { get { return ""; } }
+    protected override string TargetVariable { get { return "y"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "x17", "x18", "x19", "x20", "x21", "x22", "x23", "x24", "x25", "x26", "x27", "x28", "x29", "x30", "x31", "x32", "x33", "x34", "x35", "x36", "x37", "x38", "x39", "x40", "x41", "x42", "x43", "x44", "x45", "x46", "x47", "x48", "x49", "x50", "x51", "x52", "x53", "x54", "x55", "x56", "x57", "y" }; }
+    }
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "x17", "x18", "x19", "x20", "x21", "x22", "x23", "x24", "x25", "x26", "x27", "x28", "x29", "x30", "x31", "x32", "x33", "x34", "x35", "x36", "x37", "x38", "x39", "x40", "x41", "x42", "x43", "x44", "x45", "x46", "x47", "x48", "x49", "x50", "x51", "x52", "x53", "x54", "x55", "x56", "x57" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 711; } }
+    protected override int TestPartitionStart { get { return 711; } }
+    protected override int TestPartitionEnd { get { return 1066; } }
+  }
+}
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Housing.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Housing.cs	(revision 9133)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Housing.cs	(revision 9133)
@@ -0,0 +1,38 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Housing : ResourceRegressionDataDescriptor {
+    public override string Name { get { return "Housing"; } }
+    public override string Description { get { return ""; } }
+    protected override string TargetVariable { get { return "MEDV"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "CRIM", "ZN", "INDUS", "CHAS", "NOX", "RM", "AGE", "DIS", "RAD", "TAX", "PTRATIO", "B", "LSTAT", "MEDV" }; }
+    }
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { "CRIM", "ZN", "INDUS", "CHAS", "NOX", "RM", "AGE", "DIS", "RAD", "TAX", "PTRATIO", "B", "LSTAT" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 337; } }
+    protected override int TestPartitionStart { get { return 337; } }
+    protected override int TestPartitionEnd { get { return 506; } }
+  }
+}
Index: unk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/IRealWorldRegressionDataDescriptor.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/IRealWorldRegressionDataDescriptor.cs	(revision 9132)
+++ 	(revision )
@@ -1,29 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Data;
-
-namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  internal interface IRealWorldRegressionDataDescriptor : IDataDescriptor {
-    IntRange Training { get; }
-    IntRange Test { get; }
-  }
-}
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/RealWorldRegressionInstanceProvider.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/RealWorldRegressionInstanceProvider.cs	(revision 9132)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/RealWorldRegressionInstanceProvider.cs	(revision 9133)
@@ -24,5 +24,4 @@
 using System.IO;
 using System.Linq;
-using HeuristicLab.Problems.DataAnalysis;
 using ICSharpCode.SharpZipLib.Zip;
 
@@ -47,5 +46,7 @@
 
     public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
-      List<IRealWorldRegressionDataDescriptor> descriptorList = new List<IRealWorldRegressionDataDescriptor>();
+      List<ResourceRegressionDataDescriptor> descriptorList = new List<ResourceRegressionDataDescriptor>();
+      descriptorList.Add(new ChemicalOne());
+      descriptorList.Add(new Housing());
       descriptorList.Add(new Tower());
       var solutionsArchiveName = GetResourceName(FileName + @"\.zip");
@@ -59,30 +60,14 @@
           foreach (var entry in entries.OrderBy(x => x)) {
             string prettyName = Path.GetFileNameWithoutExtension(entry);
-            IRealWorldRegressionDataDescriptor desc = descriptorList.Where(x => x.Name.Equals(prettyName)).FirstOrDefault();
+            ResourceRegressionDataDescriptor desc = descriptorList.Where(x => x.Name.Equals(prettyName)).FirstOrDefault();
             if (desc != null) {
-              yield return new RealWorldResourceRegressionDataDescriptor(prettyName, desc.Description, entry, desc.Training, desc.Test);
+              desc.ResourceName = entry;
+              yield return desc;
             } else
-              yield return new ResourceRegressionDataDescriptor(prettyName, Description, entry);
+              throw new ArgumentNullException("No Descriptor could be found for this entry.");
           }
         }
       }
     }
-
-    public override IRegressionProblemData LoadData(IDataDescriptor id) {
-      var problem = base.LoadData(id);
-
-      var descriptor = id as RealWorldResourceRegressionDataDescriptor;
-
-      if (descriptor == null) {
-        return problem;
-      }
-
-      problem.TrainingPartition.Start = descriptor.Training.Start;
-      problem.TrainingPartition.End = descriptor.Training.End;
-      problem.TestPartition.Start = descriptor.Test.Start;
-      problem.TestPartition.End = descriptor.Test.End;
-
-      return problem;
-    }
   }
 }
Index: unk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/RealWorldResourceRegressionDataDescriptor.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/RealWorldResourceRegressionDataDescriptor.cs	(revision 9132)
+++ 	(revision )
@@ -1,35 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Data;
-
-namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  internal class RealWorldResourceRegressionDataDescriptor : ResourceRegressionDataDescriptor {
-    internal IntRange Training { get; set; }
-    internal IntRange Test { get; set; }
-
-    internal RealWorldResourceRegressionDataDescriptor(string name, string description, string resourceName, IntRange training, IntRange test)
-      : base(name, description, resourceName) {
-      Training = training;
-      Test = test;
-    }
-  }
-}
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Tower.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Tower.cs	(revision 9132)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RealWorld/Tower.cs	(revision 9133)
@@ -20,11 +20,10 @@
 #endregion
 
+using System;
 
-using System;
-using HeuristicLab.Data;
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Tower : IRealWorldRegressionDataDescriptor {
-    public string Name { get { return "Tower"; } }
-    public string Description {
+  public class Tower : ResourceRegressionDataDescriptor {
+    public override string Name { get { return "Tower"; } }
+    public override string Description {
       get {
         return "Publication: Order of Nonlinearity as a Complexity Measure for Models " +
@@ -33,6 +32,15 @@
       }
     }
-    public IntRange Training { get { return new IntRange(0, 3135); } }
-    public IntRange Test { get { return new IntRange(3135, 4999); } }
+    protected override string TargetVariable { get { return "towerResponse"; } }
+    protected override string[] VariableNames {
+      get { return new string[] { "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "x17", "x18", "x19", "x20", "x21", "x22", "x23", "x24", "x25", "towerResponse" }; }
+    }
+    protected override string[] AllowedInputVariables {
+      get { return new string[] { "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16", "x17", "x18", "x19", "x20", "x21", "x22", "x23", "x24", "x25" }; }
+    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return 3135; } }
+    protected override int TestPartitionStart { get { return 3135; } }
+    protected override int TestPartitionEnd { get { return 4999; } }
   }
 }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RegressionDataDescriptor.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RegressionDataDescriptor.cs	(revision 9133)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/RegressionDataDescriptor.cs	(revision 9133)
@@ -0,0 +1,49 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+using HeuristicLab.Problems.DataAnalysis;
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public abstract class RegressionDataDescriptor : IDataDescriptor {
+    public abstract string Name { get; }
+    public abstract string Description { get; }
+
+    protected abstract string TargetVariable { get; }
+    protected abstract string[] VariableNames { get; }
+    protected abstract string[] AllowedInputVariables { get; }
+    protected abstract int TrainingPartitionStart { get; }
+    protected abstract int TrainingPartitionEnd { get; }
+    protected abstract int TestPartitionStart { get; }
+    protected abstract int TestPartitionEnd { get; }
+
+    public IRegressionProblemData GenerateRegressionData(Dataset dataset) {
+      RegressionProblemData regData = new RegressionProblemData(dataset, AllowedInputVariables, TargetVariable);
+      regData.Name = this.Name;
+      regData.Description = this.Description;
+      regData.TrainingPartition.Start = this.TrainingPartitionStart;
+      regData.TrainingPartition.End = this.TrainingPartitionEnd;
+      regData.TestPartition.Start = this.TestPartitionStart;
+      regData.TestPartition.End = this.TestPartitionEnd;
+      return regData;
+    }
+
+  }
+}
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ResourceRegressionDataDescriptor.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ResourceRegressionDataDescriptor.cs	(revision 9132)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ResourceRegressionDataDescriptor.cs	(revision 9133)
@@ -20,15 +20,13 @@
 #endregion
 
+using System.Collections.Generic;
+using System.Linq;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  internal class ResourceRegressionDataDescriptor : IDataDescriptor {
-    public string Name { get; internal set; }
-    public string Description { get; internal set; }
+  public abstract class ResourceRegressionDataDescriptor : RegressionDataDescriptor {
+    internal string ResourceName { get; set; }
 
-    internal string ResourceName { get; set; }
-    internal ResourceRegressionDataDescriptor(string name, string description, string resourceName) {
-      Name = name;
-      Description = description;
-      ResourceName = resourceName;
+    public bool CheckVariableNames(IEnumerable<string> VariableNames) {
+      return this.VariableNames.All(x => VariableNames.Contains(x));
     }
   }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ResourceRegressionInstanceProvider.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ResourceRegressionInstanceProvider.cs	(revision 9132)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/ResourceRegressionInstanceProvider.cs	(revision 9133)
@@ -21,5 +21,4 @@
 
 using System;
-using System.Collections.Generic;
 using System.Globalization;
 using System.IO;
@@ -35,19 +34,19 @@
     protected abstract string FileName { get; }
 
-    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
-      var solutionsArchiveName = GetResourceName(FileName + @"\.zip");
-      if (!String.IsNullOrEmpty(solutionsArchiveName)) {
-        using (var solutionsZipFile = new ZipInputStream(GetType().Assembly.GetManifestResourceStream(solutionsArchiveName))) {
-          IList<string> entries = new List<string>();
-          ZipEntry curEntry;
-          while ((curEntry = solutionsZipFile.GetNextEntry()) != null) {
-            entries.Add(curEntry.Name);
-          }
-          foreach (var entry in entries.OrderBy(x => x)) {
-            yield return new ResourceRegressionDataDescriptor(Path.GetFileNameWithoutExtension(entry), Description, entry);
-          }
-        }
-      }
-    }
+    //public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
+    //  var solutionsArchiveName = GetResourceName(FileName + @"\.zip");
+    //  if (!String.IsNullOrEmpty(solutionsArchiveName)) {
+    //    using (var solutionsZipFile = new ZipInputStream(GetType().Assembly.GetManifestResourceStream(solutionsArchiveName))) {
+    //      IList<string> entries = new List<string>();
+    //      ZipEntry curEntry;
+    //      while ((curEntry = solutionsZipFile.GetNextEntry()) != null) {
+    //        entries.Add(curEntry.Name);
+    //      }
+    //      foreach (var entry in entries.OrderBy(x => x)) {
+    //        yield return new ResourceRegressionDataDescriptor(Path.GetFileNameWithoutExtension(entry), Description, entry);
+    //      }
+    //    }
+    //  }
+    //}
 
     public override IRegressionProblemData LoadData(IDataDescriptor id) {
@@ -70,18 +69,9 @@
 
         Dataset dataset = new Dataset(csvFileParser.VariableNames, csvFileParser.Values);
-        string targetVar = csvFileParser.VariableNames.Where(x => dataset.DoubleVariables.Contains(x)).Last();
-        IEnumerable<string> allowedInputVars = dataset.DoubleVariables.Where(x => !x.Equals(targetVar));
+        if (!descriptor.CheckVariableNames(csvFileParser.VariableNames)) {
+          throw new ArgumentException("Parsed file contains variables which are not in the descriptor.");
+        }
 
-        IRegressionProblemData regData = new RegressionProblemData(dataset, allowedInputVars, targetVar);
-
-        int trainingPartEnd = csvFileParser.Rows * 2 / 3;
-        regData.TrainingPartition.Start = 0;
-        regData.TrainingPartition.End = trainingPartEnd;
-        regData.TestPartition.Start = trainingPartEnd;
-        regData.TestPartition.End = csvFileParser.Rows;
-
-        regData.Name = descriptor.Name;
-        regData.Description = descriptor.Description;
-        return regData;
+        return descriptor.GenerateRegressionData(dataset);
       }
     }